/*
 * Task 4 - Toggle diode from ISR
 */

#include <msp430.h> 

int main(void) {
    WDTCTL = WDTPW | WDTHOLD;	// Stop watchdog timer

    /* Initialize */
    P2DIR &= ~BIT4;     // Initialize Button pin as input
    P2IE |= BIT4;       // Enable interrupt on pin 4
    P2IES |= BIT4;      // Falling edge on pin 4 activate interrupt

    P4DIR |= BIT3;      // Diode pin is output pin

    __bis_SR_register(GIE); //Enable global interrupt

    /* loop */
    while (1);
	
	//return 0;
}
//This is PORT2 Interrupt routine
__attribute__((interrupt(PORT2_VECTOR))) void port2_isr(void)
{
    //Check interrupt source
	if (P2IFG & BIT4) {
	    //Debounce period
		__delay_cycles(1000);
		//Check is button still pressed
		if ((P2IN & BIT4) == 0x0) {
		    //Change diode state
			P4OUT ^= BIT3;
		}
	}
	P2IFG &= ~BIT4;
}
