/*
 * Task 5 - Implement counter
 */

#include <msp430.h> 

volatile unsigned char counter = 0;

int main(void) {
    WDTCTL = WDTPW | WDTHOLD;	// Stop watchdog timer

    /* inicijalizacija */
    P2DIR &= ~(BIT4 | BIT5);
    P2IE |= BIT4 | BIT5;
    P2IES |= BIT4 | BIT5;

    P4DIR |= BIT3 | BIT4 | BIT5 | BIT6;

    __bis_SR_register(GIE);

    /* loop */
    while (1);
	
	//return 0;
}

__attribute__((interrupt(PORT2_VECTOR))) void port2_isr(void)
{
	__delay_cycles(1000);
	if (P2IFG & BIT4) {
		if ((P2IN & BIT4) == 0x0) {
			counter = (counter + 1) % 16;
		}
		P2IFG &= ~BIT4;
	}
	if (P2IFG & BIT5) {
		if ((P2IN & BIT5) == 0x0) {
			counter = (counter - 1) % 16;
		}
		P2IFG &= ~BIT5;
	}
	P4OUT &= ~(BIT3 | BIT4 | BIT5 | BIT6);
	P4OUT = counter << 3;
}
