/*
 * Task 6 - Print digit on 7seg display
 */

#include <msp430.h> 

volatile unsigned char counter = 0;

const unsigned char tabela[] =
{
	/*    xabcdefg */
		0b01111110,
		0b00110000,
		0b01101101,
		0b01111001,
		0b00110011,
		0b01011011,
		0b01011111,
		0b01110000,
		0b01111111,
		0b01111011,
		0b01110111,
		0b00011111,
		0b01001110,
		0b00111101,
		0b01001111,
		0b01000111
};

int main(void) {
    WDTCTL = WDTPW | WDTHOLD;	// Stop watchdog timer

    /* inicijalizacija */
    P2DIR &= ~(BIT4 | BIT5);
    P2IE |= BIT4 | BIT5;
    P2IES |= BIT4 | BIT5;

    P11DIR |= BIT1;	/* selektovan displej 1 */
    P6DIR |= ~BIT7;	/* a-g */
    P11OUT &= ~BIT1;	/* ukljuci displej 1 */

    __bis_SR_register(GIE);

    /* loop */
    while (1) {
    	P6OUT = tabela[counter];
    }
	
	//return 0;
}

__attribute__((interrupt(PORT2_VECTOR))) void port2_isr(void)
{
	__delay_cycles(1000);
	if (P2IFG & BIT4) {
		if ((P2IN & BIT4) == 0x0) {
			counter = (counter + 1) & 0x0f;
		}
		P2IFG &= ~BIT4;
	}
	if (P2IFG & BIT5) {
		if ((P2IN & BIT5) == 0x0) {
			counter = (counter - 1) & 0x0f;
		}
		P2IFG &= ~BIT5;
	}
}
